/******************************************************************************/
/******************************************************************************/

;(function($,doc,win) 
{
	"use strict";
	
	var preloaderImage=function(object,option)
	{
		/**********************************************************************/
		
		var $this=$(object);
		
		var $optionDefault=
		{
			onReady						:	'',
			animationEnable				:	true
		};
		
		var $option=$.extend($optionDefault,option);

		/**********************************************************************/

		this.create=function() 
		{
			var self=this;
	
			$this.find('.pb-preloader-image img,.theme-preloader-image img').each(function() 
			{
				if($(this).hasClass('preloader-image-process')) return;
				$(this).addClass('preloader-image-process');

				$(this).attr('src',$(this).attr('src')+'?i='+self.getRandom(1,100000));
				$(this).bind('load',function() 
				{ 
					if(!$option.animationEnable)
					{
						$(this).css({'opacity':1});
						$(this).parent().removeClass('pb-preloader-image').removeClass('theme-preloader-image');
						$(this).unbind('load');
					}
					else
					{
						var height=parseInt($(this).actual('height'));

						$(this).parent().animate({height:height},500,function() 
						{
							$(this).css({'height':'auto'});

							$(this).children('img').animate({opacity:1},300,function() 
							{					
								$(this).parent().removeClass('pb-preloader-image').removeClass('theme-preloader-image');
								$(this).unbind('load');
							}); 
						});
					}
				});
			});	
			
			if($option.onReady!==false) self.wait();
		};
		
		/**********************************************************************/
	
		this.wait=function()
		{
			var self=this;
			var preloaderClock=window.setTimeout(function() 
			{
				if($this.find('.pb-preloader-image,.theme-preloader-image').length)
					self.wait($this,$option.onReady);
				else
				{
					window.clearTimeout(preloaderClock);
					$option.onReady.call();
				}
			},200);	
		};
		
		/**********************************************************************/
		
		this.getRandom=function(min,max)
		{
			return((Math.floor(Math.random()*(max-min)))+min);
		};

		/**********************************************************************/
	}
	
	/**************************************************************************/
	
	$.fn.preloaderImage=function(option) 
	{
		var element=new preloaderImage(this,option);
		element.create();
	};
	
	/**************************************************************************/

})(jQuery,document,window);