<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentCounterBox extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$Layout=new PBLayout();
		$Easing=new PBEasing();
		$CarouFredSel=new PBCarouFredSel();
		
		$this->style=array
		(
			'counter-box'														=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);	
		
		$this->script=array
		(
			'counter-box'														=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'PB.CounterBox.js'
			)
		);
		
		$this->layout=$Layout->getMainLayout();

		$this->component=array
		(
			'name'																=>	__('Counter Box',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays Counter Box',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Counter Box',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'ui'															=>	array
				(
					'panel'														=>	array
					(
						1														=>	array
						(
							'header'											=>	__('General',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						2														=>	array
						(
							'header'											=>	__('Carousel',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						3														=>	array
						(
							'header'											=>	__('Animations',PLUGIN_PAGE_BUILDER_DOMAIN)
						)
					)
				),	
				'element'														=>	array
				(
					array
					(
						'id'													=>	'category',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Category',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select one or more categories from which data have to be retrieved.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'term',
								'dictionary'									=>	array
								(
									'term'										=>	PLUGIN_PAGE_BUILDER_CONTEXT.'_counter_category'
								)
							)
						)
					),
					array
					(
						'id'													=>	'layout',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Layout',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select layout of the counter boxes.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->layout,'name')
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'100'
						)
					),					
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space.',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),
					array
					(
						'id'													=>	'carousel_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Enable carousel',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable carousel',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	1
						)
					),	
					array
					(
						'id'													=>	'carousel_autoplay_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Autoplay',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Autoplay',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	0
						)
					),						
					array
					(
						'id'													=>	'carousel_circular_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Circular',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the carousel should be circular',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	1
						)
					),						
					array
					(
						'id'													=>	'carousel_infinite_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Infinite',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the carousel should be infinite',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	1
						)
					),
					array
					(
						'id'													=>	'carousel_scroll_pause_hover',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Pause on hover',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the timeout between transitions should be paused',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	1
						)
					),
					array
					(
						'id'													=>	'carousel_scroll_fx',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Scroll effect',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Indicates which effect to use for the transition',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($CarouFredSel->scrollFX)
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'scroll'
						)
					),						
					array
					(
						'id'													=>	'carousel_scroll_easing',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Easing',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Indicates which easing function to use for the transition',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($Easing->easingType)
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'easeInQuad'
						)
					),						
					array
					(
						'id'													=>	'carousel_scroll_duration',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Duration',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines the duration of the transition in milliseconds',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'500'
						)
					),	
					array
					(
						'id'													=>	'animation_start_enable',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Counter and progress bar animation',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Run animation on start',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	1
						)
					),
					array
					(
						'id'													=>	'animation_start_duration',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Duration of counter and progress bar animation',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines the duration of the animation in milliseconds',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	5
								)	
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'500'
						)
					)
				)
			)
		);		
		
		parent::__construct();
	}
	
	/**************************************************************************/
	
	function processShortcodeCounterBox($attribute,$content,$tag)
	{
		global $post;
		
		$Layout=new PBLayout();
		$Easing=new PBEasing();
		$Validation=new PBValidation();
		$CarouFredSel=new PBCarouFredSel();
		
		$attribute=$this->processAttribute($tag,$attribute);

		if(!array_key_exists($attribute['layout'],$this->layout)) return(null);
		
		$data=$this->getCounterBox($attribute);

		if($data===false) return(null);
		if(!count($data->posts)) return(null);
		
		if(!$Validation->isBool($attribute['carousel_enable'])) return(null);

		if(!$Validation->isBool($attribute['carousel_autoplay_enable'])) return(null);
		if(!$Validation->isBool($attribute['carousel_circular_enable'])) return(null);
		if(!$Validation->isBool($attribute['carousel_infinite_enable'])) return(null);
		
		if(!$Validation->isBool($attribute['carousel_scroll_pause_hover'])) return(null);

		if(!array_key_exists($attribute['carousel_scroll_fx'],$CarouFredSel->scrollFX)) return(null);
		if(!array_key_exists($attribute['carousel_scroll_easing'],$Easing->easingType)) return(null);
		if(!$Validation->isNumber($attribute['carousel_scroll_duration'],1,99999)) return(null);

		if(!$Validation->isBool($attribute['animation_start_enable'])) return;
		if(!$Validation->isNumber($attribute['animation_start_duration'],1,99999)) return(null);		
		
		$carouselOption=array();
		$key=array
		(
			'carousel_enable',
			'carousel_autoplay_enable',
			'carousel_circular_enable',
			'carousel_infinite_enable',
			'carousel_scroll_pause_hover',
			'carousel_scroll_fx',
			'carousel_scroll_easing',
			'carousel_scroll_duration',
			'animation_start_enable',
			'animation_start_duration'
		);
		foreach($key as $index)
			$carouselOption[$index]=$attribute[$index];
		
		$animationOption=array();
		$key=array
		(
			'animation_start_enable',
			'animation_start_duration'
		);
		foreach($key as $index)
			$animationOption[$index]=$attribute[$index];		
	
		$i=0;
		$html=null;
		
		global $post;
		$bPost=$post;
		
		while($data->have_posts())
		{
			$data->the_post();
			
			$option=PBHelper::getPostMeta($post);
			
			$counterHTML=null;
			if($option['counter_counter_type']==1)
			{
				$counterHTML=
				'
					<div class="pb-counter-box-counter">
						<div class="pb-counter-box-counter-value value-'.(int)$option['counter_counter_percent_value'].'">'.(int)$option['counter_counter_percent_value'].'</div><div class="pb-counter-box-counter-character">%</div>
					</div>	
				';
			}
			else
			{
				$counterCharacterHTML='<div class="pb-counter-box-counter-character">'.$option['counter_counter_custom_character'].'</div>';
				
				$counterHTML=
				'
					<div class="pb-counter-box-counter">
						'.($option['counter_counter_custom_character_position']==1 ? $counterCharacterHTML : null).'<div class="pb-counter-box-counter-value value-'.(int)$option['counter_counter_custom_value'].'">'.(int)$option['counter_counter_custom_value'].'</div>'.($option['counter_counter_custom_character_position']==2 ? $counterCharacterHTML : null).'
					</div>						
				';
			}
			
			$barHTML=null;
			if($option['counter_counter_type']==1)
			{
				$barHTML=
				'
					<div class="pb-counter-box-progress-bar value-'.(int)$option['counter_counter_percent_value'].'">
						<div class="pb-counter-box-progress-bar-background"></div>
						<div class="pb-counter-box-progress-bar-foreground" style="width:'.(int)$option['counter_counter_percent_value'].'%"></div>
					</div>
				';
			}
			
			$class=array('pb-layout-'.$Layout->getLayoutColumnCSSClass($attribute['layout'],$i));
			
			$html.=
			'
				<li'.PBHelper::createClassAttribute($class).'>
					<div>
						'.$counterHTML.'
						<h4>'.get_the_title().'</h4>
						'.apply_filters('the_content',do_shortcode(get_the_content())).'
						'.$barHTML.'
					</div>
				</li>
			';
			
			$i++;
		}
		
		wp_reset_query();
		$post=$bPost;
		
		$id=PBHelper::createId('pb_counter_box');
		
		$class=array();
		
		$class[0]=array
		(
			'pb-counter-box',
			'pb-clear-fix',
			$attribute['css_class']
		);
		
		$class[1]=array
		(
			'pb-reset-list',
			'pb-clear-fix',
			$Layout->getLayoutCSSClass($attribute['layout'])
		);
		
		$html=
		'
			<div'.PBHelper::createClassAttribute($class[0]).' id="'.$id.'">
				<ul'.PBHelper::createClassAttribute($class[1]).'>
					'.$html.'
				</ul>
				<div class="pb-slider-pagination"></div>
			</div>
			<div class="pb-script-tag">
				<script type="text/javascript">
					jQuery(document).ready(function($) 
					{
						$("#'.$id.'").PBCounterBox('.json_encode($carouselOption).','.json_encode($animationOption).');
					});
				</script>
			</div>
		';
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
	
	function getCounterBox($attribute)
	{
		$argument=array
		(
			'post_type'										=>	PLUGIN_PAGE_BUILDER_CONTEXT.'_counter',
			PLUGIN_PAGE_BUILDER_CONTEXT.'_counter_category'		=>	$attribute['category'],
			'posts_per_page'								=>	-1,
			'orderby'										=>	'menu_order',
			'order'											=>	'asc'
		);
		
		$query=new WP_Query($argument);
		if($query===false) return;
		
		return($query);
	}
	
	/**************************************************************************/
	
	function initCustomPostType()
	{
		add_action('init',array($this,'adminInit')); 
		add_action('save_post',array($this,'adminSaveMetaBox'));
		add_action('add_meta_boxes',array($this,'adminInitMetaBox'));
		add_filter('manage_edit-'.PLUGIN_PAGE_BUILDER_CONTEXT.'_counter_columns',array($this,'adminManageEditColumn')); 
		add_action('manage_'.PLUGIN_PAGE_BUILDER_CONTEXT.'_counter_posts_custom_column',array($this,'adminManageColumn'));
		add_filter('manage_edit-'.PLUGIN_PAGE_BUILDER_CONTEXT.'_counter_sortable_columns',array($this,'adminManageEditSortableColumn'));	
	}
	
	/**************************************************************************/
	
	function adminInit()
	{
		register_post_type
		(
			PLUGIN_PAGE_BUILDER_CONTEXT.'_counter',
			array
			(  
				'labels'							=>	array
				(
					'name'							=>	__('Counter Box',PLUGIN_PAGE_BUILDER_DOMAIN),
					'singular_name'					=>	__('Counter Boxes',PLUGIN_PAGE_BUILDER_DOMAIN),
					'add_new'						=>	__('Add New',PLUGIN_PAGE_BUILDER_DOMAIN),
					'add_new_item'					=>	__('Add New Counter Box',PLUGIN_PAGE_BUILDER_DOMAIN),
					'edit_item'						=>	__('Edit Counter Box',PLUGIN_PAGE_BUILDER_DOMAIN),
					'new_item'						=>	__('New Counter Box',PLUGIN_PAGE_BUILDER_DOMAIN),
					'all_items'						=>	__('All Counter Boxes',PLUGIN_PAGE_BUILDER_DOMAIN),
					'view_item'						=>	__('View Counter Box',PLUGIN_PAGE_BUILDER_DOMAIN),
					'search_items'					=>	__('Search Counter Box',PLUGIN_PAGE_BUILDER_DOMAIN),
					'not_found'						=>	__('No Counter Boxes found',PLUGIN_PAGE_BUILDER_DOMAIN),
					'not_found_in_trash'			=>	__('No Counter Boxes found in Trash',PLUGIN_PAGE_BUILDER_DOMAIN), 
					'parent_item_colon'				=>	'',
					'menu_name'						=>	__('Counter Boxes',PLUGIN_PAGE_BUILDER_DOMAIN)
				), 
				'public'							=>	false,  
				'show_ui'							=>	true,  
				'capability_type'					=>	'post',
				'hierarchical'						=>	false,  
				'rewrite'							=>	false,  
				'supports'							=>	array('title','editor','page-attributes')
			)				
		);  
		
		register_taxonomy
		(
			PLUGIN_PAGE_BUILDER_CONTEXT.'_counter_category',
			array(PLUGIN_PAGE_BUILDER_CONTEXT.'_counter'),
			array
			(
				'label'								=>	__('Categories',PLUGIN_PAGE_BUILDER_DOMAIN),
				'labels'							=>	array
				(
					'name'							=>	__('Counter Boxes categories',PLUGIN_PAGE_BUILDER_DOMAIN),		 
					'singular_name'					=>	__('Counter Box category',PLUGIN_PAGE_BUILDER_DOMAIN),		 
					'menu_name'						=>	__('Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'all_items'						=>	__('All Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'edit_item'						=>	__('Edit Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'view_item'						=>	__('View Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'update_item'					=>	__('Update Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'add_new_item'					=>	__('Add New Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'new_item_name'					=>	__('New Category Name',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'parent_item'					=>	__('Parent Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'parent_item_colon'				=>	__('Parent Category:',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'search_items'					=>	__('Search Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'popular_items'					=>	__('Popular Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'separate_items_with_commas'	=>	__('Separate categories with commas',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'add_or_remove_items'			=>	__('Add or remove categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'choose_from_most_used'			=>	__('Choose from the most used categories',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'hierarchical'						=>	true
			)
		); 	
	}
	
	/**************************************************************************/
	
	function adminCreateMetaBox()
	{
		global $post;
		
		$data=array();

		$data['option']=PBHelper::getPostMeta($post);
		$data['nonce']=wp_nonce_field('adminSaveMetaBox',PLUGIN_PAGE_BUILDER_CONTEXT.'_counter_noncename',false,false);
		
		PBHelper::setDeafultOption($data['option'],'counter_counter_type',1);
		PBHelper::setDeafultOption($data['option'],'counter_counter_percent_value',50);
		PBHelper::setDeafultOption($data['option'],'counter_counter_custom_value',null);
		
		PBHelper::setDeafultOption($data['option'],'counter_counter_custom_character',null);
		PBHelper::setDeafultOption($data['option'],'counter_counter_custom_character_position',2);
		
		$Template=new PBTemplate($data,$this->getTemplateFullPath('meta_box'));
		echo $Template->output();				
	}
	
	/**************************************************************************/
	
	function adminInitMetaBox()
	{
		add_meta_box(PLUGIN_PAGE_BUILDER_CONTEXT.'_counter',__('Options'),array($this,'adminCreateMetaBox'),PLUGIN_PAGE_BUILDER_CONTEXT.'_counter','normal','high');	
	}
	
	/**************************************************************************/
	
	function adminSaveMetaBox($postId)
	{
		if($_POST)
		{
			if(PBHelper::checkSavePost($postId,PLUGIN_PAGE_BUILDER_CONTEXT.'_counter_noncename','adminSaveMetaBox')===false) return(false);
			
			$option=PBHelper::getPOSTOption('counter');
			
			unset($option['counter_counter_percent_value_slider_option']);
	
			update_post_meta($postId,PLUGIN_PAGE_BUILDER_CONTEXT,$option);
		}		
	}
	
	/**************************************************************************/
	
	function adminManageEditColumn($column)
	{
		$column=array
		(  
			'cb'					=>	'<input type="checkbox"/>',
			'counter_title'			=>	__('Title',PLUGIN_PAGE_BUILDER_DOMAIN),
			'counter_value'			=>	__('Value',PLUGIN_PAGE_BUILDER_DOMAIN)   
		);    

		return($column);  		
	}
	
	/**************************************************************************/
	
	function adminManageColumn($column)
	{
		global $post;
		$option=PBHelper::getPostMeta($post);

		PBHelper::removeUIndex($option,'counter_counter_type','counter_counter_percent_value','counter_counter_custom_value');
		
		switch($column)  
		{
			case 'counter_title':   
				echo '<a href="'.get_edit_post_link($post->ID).'">'.get_the_title($post->ID).'</a>'; 
			break;
			case 'counter_value':   
				echo '<a href="'.get_edit_post_link($post->ID).'">'.(int)($option['counter_counter_type']==1 ? (int)$option['counter_counter_percent_value'] : (int)$option['counter_counter_custom_value']).'</a>'; 
			break;
		}  
		
		return($column);		
	}
	
	/**************************************************************************/
	
	function adminManageEditSortableColumn($column)
	{
		$column['counter_title']='title';
		$column['counter_percent']='title';
		return($column);		
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>