/******************************************************************************/
/******************************************************************************/

;(function($,doc,win) 
{
	"use strict";
	
	var PBCounterBox=function(object,carouselOption,animationOption)
	{
		/**********************************************************************/
		
		var $this=$(object);
		var $carouselOption=carouselOption;
		var $animationOption=animationOption;

		/**********************************************************************/

		this.build=function() 
		{			
			var helper=new PBHelper();
			
			if($carouselOption.carousel_enable==1)
				$this.children('ul').addClass('pb-layout-responsive-0');
			
			helper.createCarousel($this,$carouselOption);
			
			if($animationOption.animation_start_enable==1)
				this.animate();
		};
		
		/**********************************************************************/
		
		this.animate=function()
		{
			var self=this;
			
			var helper=new PBHelper();
			
			$this.find('.pb-counter-box-counter-value').html('0');
			$this.find('.pb-counter-box-progress-bar>.pb-counter-box-progress-bar-foreground').css({'width':'0'});
						
			$this.find('ul>li>div').waypoint(function()
			{
				if(!helper.isAnimationComplete($(this)))
				{
					helper.setAnimationAsComplete($(this));
				
					var	value;
					
					var counter=$(this).children('.pb-counter-box-counter').children('.pb-counter-box-counter-value');
					var progress=$(this).children('.pb-counter-box-progress-bar');
					
					if((value=self.getValue(counter))==false)
					{
						if((value=self.getValue(progress))==false) return;
					}
					
					var i=0;
					var clockCounterBox=window.setInterval(function() 
					{
						i++;
						
						if(counter.length==1) counter.html(i);
						if(progress.length==1) progress.find('.pb-counter-box-progress-bar-foreground').css('width',i+'%');
						
						if(i==value.limit)
							window.clearInterval(clockCounterBox);
							
					},value.interval)
				}
			},
			{
				offset	:	'90%'
			});		
		};
		
		/**********************************************************************/
		
		this.getValue=function(object)
		{
			if(object.length!=1) return(false);
			
			var helper=new PBHelper();
			
			var value={};
			
			value.limit=helper.getValueFromClass(object,'value-');
			value.interval=($animationOption.animation_start_duration)/value.limit;
			
			return(value);
		};
		
		/**********************************************************************/
	}
	
	/**************************************************************************/
	
	$.fn.PBCounterBox=function(carouselOption,animationOption) 
	{
		var object=new PBCounterBox(this,carouselOption,animationOption);
		object.build();
	};
	
	/**************************************************************************/

})(jQuery,document,window);

/******************************************************************************/
/******************************************************************************/