<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentGallery extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$Layout=new PBLayout();
		
		$this->style=array
		(
			'gallery'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);	
		
		$this->script=array
		(
			'gallery'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'PB.Gallery.js'
			)
		);
		
		$this->layout=$Layout->getMainLayout();
		
		$this->component=array
		(
			'name'																=>	__('Gallery',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays Gallery',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Gallery',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'element'														=>	array
				(
					array
					(
						'id'													=>	'image',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Images',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Click on below button to create gallery with images to the slider',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'gallery'
							)
						),
					),	
					array
					(
						'id'													=>	'image_size',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Image size',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select image size',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'image-size'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	PBComponentData::get($this->getComponentId(),'image_default')
						)
					),	
					array
					(
						'id'													=>	'layout',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Layout',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select layout of the images in gallery',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->layout,'name')
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'33x33x33'
						)
					),	
					array
					(
						'id'													=>	'preloader_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Preloader',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable preloader on images',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),
					array
					(
						'id'													=>	'hover_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Hover',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable hover on images',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),
					array
					(
						'id'													=>	'caption_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Caption',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable displaying captions under images',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),
					array
					(
						'id'													=>	'description_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Description',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable displaying descriptions under images',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),	
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					)
				)
			)
		);
		
		parent::__construct();		
	}
	
	/**************************************************************************/
	
	function processShortcodeGallery($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);

		$html=null;
		$imageHTML=null;
		
		$Layout=new PBLayout();
		$Validation=new PBValidation();

		$file=PBFile::getImage(explode(',',$attribute['image']));

		if($file===false) return;
		if(!count($file->posts)) return;
		
		if(!PBFile::isWPImage($attribute['image_size'])) return;
		if(!array_key_exists($attribute['layout'],$this->layout)) return;
		
		if(!$Validation->isBool($attribute['hover_enable'])) return;
		if(!$Validation->isBool($attribute['caption_enable'])) return;
		if(!$Validation->isBool($attribute['preloader_enable'])) return;
		if(!$Validation->isBool($attribute['description_enable'])) return;
		
		$key=array
		(
			'hover_enable',
			'preloader_enable'
		);
		
		foreach($key as $index)
			$option[$index]=$attribute[$index];		
		
		$id=PBHelper::createId('pb_gallery');
		
		global $post;
		$bPost=$post;		
		
		$i=0;
		while($file->have_posts())
		{
			global $post;
			
			$file->the_post();
			
			$full=wp_get_attachment_image_src(get_post_thumbnail_id(),'full');
			$thumbnail=wp_get_attachment_image_src(get_post_thumbnail_id(),$attribute['image_size']);
			
			$meta=PBHelper::getPostMeta($post);
			PBHelper::removeUIndex($meta,'media_library_video_url','media_library_url');
			
			$class=array(array(),array());
			
			$class[0]=array('pb-layout-'.$Layout->getLayoutColumnCSSClass($attribute['layout'],$i));
			
			if($attribute['preloader_enable']==1)
			{
				array_push($class[1],'pb-preloader-image');
			}
			
			$textHTML=null;
			if(($Validation->isNotEmpty($post->post_excerpt)) && ($attribute['caption_enable']==1))
				$textHTML.='<div class="pb-gallery-text-box-caption">'.$post->post_excerpt.'</div>';
			if(($Validation->isNotEmpty($post->post_content)) && ($attribute['description_enable']==1))
				$textHTML.='<div class="pb-gallery-text-box-description">'.$post->post_content.'</div>';
			
			if($Validation->isNotEmpty($textHTML))
				$textHTML='<div class="pb-gallery-text-box">'.$textHTML.'</div>';
			
			$url=null;
			$rel=null;
			
			if($Validation->isVideoURL($meta['media_library_video_url']))
			{
				$url=$meta['media_library_video_url'];
				array_push($class[0],'pb-gallery-item-type-video');
			}
			elseif($Validation->isURL($meta['media_library_url']))
			{
				$url=$meta['media_library_url'];
				array_push($class[0],'pb-gallery-item-type-link');
			}
			else
			{
				$rel=$id;
				$url=$full[0];
				array_push($class[0],'pb-gallery-item-type-image');
			}
			
			$imageHTML.=
			'
				<li'.PBHelper::createClassAttribute($class[0]).'>
					<div class="pb-gallery-image-box">
						<a href="'.$url.'"'.PBHelper::createClassAttribute($class[1]).($Validation->isEmpty($rel) ? null : ' data-fancybox-group="'.esc_attr($rel).'"').'>
							<img src="'.$thumbnail[0].'" alt=""/>
							<span><span></span></span>
						</a>
					</div>
					'.$textHTML.'
				</li>
			';
			
			$i++;
		}
		
		wp_reset_query();
		$post=$bPost;
				
		$class=array();
		
		$class[0]=array('pb-gallery','pb-clear-fix',$attribute['css_class']);
		$class[1]=array($Layout->getLayoutCSSClass($attribute['layout']),'pb-reset-list','pb-clear-fix');

		$html=
		'
			<div'.PBHelper::createClassAttribute($class[0]).' id="'.$id.'">
				<ul'.PBHelper::createClassAttribute($class[1]).'>
					'.$imageHTML.'
				</ul>			
			</div>
			<div class="pb-script-tag">
				<script type="text/javascript">
					jQuery(document).ready(function($)
					{
						$(\'#'.$id.'\').PBGallery('.json_encode($option).');
					});
				</script>
			</div>
		';
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>