/******************************************************************************/
/******************************************************************************/

;(function($,doc,win) 
{
	"use strict";
	
	var PBGoogleMap=function(object,option)
	{
		/**********************************************************************/
		
		var $this=$(object);
		var $option=option;

		/**********************************************************************/

		this.build=function() 
		{
			try
			{
				var object=$this;
				object.css({width:$option.width+'%',height:$option.height+'px'});		

				var coordinate=new google.maps.LatLng($option.coordinate_lat,$option.coordinate_lng);

				var mapOptions= 
				{
					center						:	coordinate,
					draggable					:	parseInt($option.draggable)==1 ? true : false,
					scrollwheel					:	parseInt($option.scrollwheel)==1 ? true : false,
					mapTypeId					:	google.maps.MapTypeId[$option.map_type_id],
					mapTypeControl				:	parseInt($option.map_type_control_enable),
					mapTypeControlOptions		: 
					{
						style					:	google.maps.MapTypeControlStyle[$option.map_type_control_style],
						position				:	google.maps.ControlPosition[$option.map_type_control_position]
					},
					zoom						:	parseInt($option.zoom_level),
					zoomControl					:	parseInt($option.zoom_control_enable)==1 ? true : false,
					zoomControlOptions			: 
					{
						style					:	google.maps.ZoomControlStyle[$option.zoom_style],
						position				:	google.maps.ControlPosition[$option.zoom_position]
					},
					panControl					:	parseInt($option.pan_control_enable)==1 ? true : false,
					panControlOptions			: 
					{
						position				:	google.maps.ControlPosition[$option.pan_control_position]
					},
					scaleControl				:	parseInt($option.scale_control_enable)==1 ? true : false,
					scaleControlOptions			: 
					{
						position				:	google.maps.ControlPosition[$option.scale_control_position]
					},
					streetViewControl			:	parseInt($option.street_view_enable)==1 ? true : false,
					streetViewControlOptions	: 
					{
						position				:	google.maps.ControlPosition[$option.street_view_position]
					},
					styles						: 
					[
						{
							stylers				: 
							[
								{ 
									saturation	:	parseInt($option.saturation)
								}
							]
						}
					]
				}

				var googleMap=new google.maps.Map(document.getElementById(object.attr('id')),mapOptions);

				if(($option.coordinate_marker_lat.length!=0) && ($option.coordinate_marker_lng.length!=0) && ($option.marker_image_url.length!=0))
				{
					coordinate=new google.maps.LatLng($option.coordinate_marker_lat,$option.coordinate_marker_lng);

					var markerOptions=
					{
						map			:	googleMap,
						position	:	coordinate,
						icon		:	$option.marker_image_url
					}

					new google.maps.Marker(markerOptions);

					jQuery(window).resize(function() 
					{
						var currCenter=googleMap.getCenter();

						google.maps.event.trigger(googleMap,'resize');
						googleMap.setCenter(currCenter);
					});
				};

				google.maps.event.addListenerOnce(googleMap,'idle',function()
				{
					if(parseInt($option.scrollwheel)!==1) 
					{
						googleMap.set('scrollwheel',true);
					
						var child=$('#'+object.attr('id')).children('div');
					
						var gmLayer=$('<div>');
		
						gmLayer.css({'position':'absolute','width':'100%','height':'100%','z-index':0});
										
						child.append(gmLayer);
					}
				});
			}
			catch(e) {}		
		};
	}
	
	/**************************************************************************/
	
	$.fn.PBGoogleMap=function(option) 
	{
		var map=new PBGoogleMap(this,option);
		map.build();
	};
	
	/**************************************************************************/

})(jQuery,document,window);