<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentHeaderSubheader extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$this->style=array
		(
			'header-subheader'													=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);
		
		$this->headerImportant=array
		(
			'1'																	=>	array(__('H1',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'2'																	=>	array(__('H2',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'3'																	=>	array(__('H3',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'4'																	=>	array(__('H4',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'5'																	=>	array(__('H5',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'6'																	=>	array(__('H6',PLUGIN_PAGE_BUILDER_DOMAIN))
		);
		
		$this->component=array
		(
			'name'																=>	__('Header + Subheader',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays header + subheader',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Header + Subheader',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'element'														=>	array
				(
					array
					(
						'id'													=>	'header_content',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Header',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Content of the header',PLUGIN_PAGE_BUILDER_DOMAIN),
							)
						),
						'shortcode'												=>	array
						(
							'path'												=>	'header/@content'
						)
					),
					array
					(
						'id'													=>	'header_important',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Important of the header',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->headerImportant),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'3',
							'path'												=>	'header/@important'
						)
					),
					array
					(
						'id'													=>	'subheader',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Subheader',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Content of the subheader',PLUGIN_PAGE_BUILDER_DOMAIN),
							)
						),
						'shortcode'												=>	array
						(
							'path'												=>	'subheader/@content'
						)
					),
					array
					(
						'id'													=>	'subheader_important',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Important of the subheader',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->headerImportant),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'3',
							'path'												=>	'subheader/@important'
						)
					),										
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space.',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),					
				)
			)
		);	
		
		parent::__construct();
	}
	
	/**************************************************************************/
	
	function processShortcodeHeaderSubheader($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);
		
		$class=array('pb-header-subheader',$attribute['css_class']);
		
		$html=
		'
			<div'.PBHelper::createClassAttribute($class).'>
				'.do_shortcode($content).'
			</div>
		';	
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
	
	function processShortcodeHeaderSubheaderHeader($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);
		
		$Validation=new PBValidation();
		
		if($Validation->isEmpty($content)) return(null);
		
		if(!in_array($attribute['important'],array_keys($this->headerImportant))) return(null);
	
		$class=array('pb-header');
		
		$html=
		'
			<h'.(int)$attribute['important'].PBHelper::createClassAttribute($class).'>
				<span class="pb-header-content">'.do_shortcode($content).'</span>
			</h'.(int)$attribute['important'].'>
		';
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
	
	function processShortcodeHeaderSubheaderSubheader($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);
		
		$Validation=new PBValidation();
		
		if($Validation->isEmpty($content)) return(null);
		
		if(!in_array($attribute['important'],array_keys($this->headerImportant))) return(null);
	
		$class=array('pb-subheader');
		
		$html=
		'
			<h'.(int)$attribute['important'].PBHelper::createClassAttribute($class).'>
				<span class="pb-subheader-content">'.do_shortcode($content).'</span>
			</h'.(int)$attribute['important'].'>
		';
		
		return(PBHelper::formatCode($html));		
	}
	
	/**************************************************************************/
	
}

/******************************************************************************/
/******************************************************************************/

?>