<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentImageCarousel extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$Easing=new PBEasing();
		$Carousel=new PBCarouFredSel();
		
		$this->style=array
		(
			'image-carousel'													=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);	
		
		$this->script=array
		(
			'image-carousel'													=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'PB.ImageCarousel.js'
			)
		);
		
		$this->component=array
		(
			'name'																=>	__('Image Carousel',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays Image Carousel',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Image Carousel',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'ui'															=>	array
				(
					'panel'														=>	array
					(
						1														=>	array
						(
							'header'											=>	__('General',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						2														=>	array
						(
							'header'											=>	__('Images',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						3														=>	array
						(
							'header'											=>	__('Carousel',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						4														=>	array
						(
							'header'											=>	__('Captions',PLUGIN_PAGE_BUILDER_DOMAIN)
						)
					)
				),
				'element'														=>	array
				(
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						),
					),
					array
					(
						'id'													=>	'image',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Images',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Click on below button to create gallery with images to the slider',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'gallery'
							)
						),
					),	
					array
					(
						'id'													=>	'image_size',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Image size',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select image size',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'image-size'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	PBComponentData::get($this->getComponentId(),'image_default')
						)
					),		
					array
					(
						'id'													=>	'autoplay_enable',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Autoplay',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the carousel should scroll automatically or not',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),			
					array
					(
						'id'													=>	'circular_enable',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Circular',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the carousel should be circular',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),						
					array
					(
						'id'													=>	'infinite_enable',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Infinite',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the carousel should be infinite',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),	
					array
					(
						'id'													=>	'touch_enable',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Scroll via swiping gestures',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the carousel should scroll via swiping gestures (on touch-devices only)',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),	
					array
					(
						'id'													=>	'mouse_enable',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Scroll via dragging',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the carousel should scroll via dragging (on non-touch-devices only)',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),	
					array
					(
						'id'													=>	'preloader_enable',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Preloader',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable carousel preloader',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),	
					array
					(
						'id'													=>	'carousel_height_adjust',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Adjust carousel height',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Adjust height of carousel to the screen height (if image is higher than screen height)',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),						
					array
					(
						'id'													=>	'pause_on_hover',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Pause on hover',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the timeout between transitions should be paused',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($Carousel->pauseOnHover),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	''
						)
					),	
					array
					(
						'id'													=>	'direction',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Direction',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('The direction to scroll the carousel',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($Carousel->direction),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'left'
						)
					),					
					array
					(
						'id'													=>	'timeout_duration',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Timeout duration',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('The amount of milliseconds the carousel will pause',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	5
								)	
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'2500'
						)
					),						
					array
					(
						'id'													=>	'delay',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Delay',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Additional delay in milliseconds before the carousel starts scrolling the first time.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	5
								)	
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),						
					array
					(
						'id'													=>	'scroll_item',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Scroll items',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('The number of items to scroll',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	3
								)	
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),						
					array
					(
						'id'													=>	'scroll_duration',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Transition duration',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines the duration of the transition in milliseconds',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	5
								)	
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'500'
						)
					),					
					array
					(
						'id'													=>	'scroll_fx',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Transition effect',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Indicates which effect to use for the transition',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($Carousel->scrollFX),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'scroll'
						)
					),					
					array
					(
						'id'													=>	'scroll_easing',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Transition easing',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Indicates which easing function to use for the transition',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($Easing->easingType),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'swing'
						)
					),
					array
					(
						'id'													=>	'caption_box_position',
						'ui'													=>	array
						(
							'panel'												=>	4,
							'text'												=>	array
							(
								'header'										=>	__('Caption box position',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Position of captions box (in % from the TOP of the carousel).',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'slider',
								'value'											=>	33,
								'option'										=>	array
								(
									'min'										=>	0,
									'max'										=>	100
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'33'
						)
					),	
					array
					(
						'id'													=>	'pagination_box_position',
						'ui'													=>	array
						(
							'panel'												=>	4,
							'text'												=>	array
							(
								'header'										=>	__('Pagination position',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Position of pagination (in % from the BOTTOM of the carousel).',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'slider',
								'value'											=>	10,
								'option'										=>	array
								(
									'min'										=>	0,
									'max'										=>	100
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'10'
						)
					),
					array
					(
						'id'													=>	'header_font_size',
						'ui'													=>	array
						(
							'panel'												=>	4,
							'text'												=>	array
							(
								'header'										=>	__('Header font size',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Header font size (in PX).',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'slider',
								'value'											=>	88,
								'option'										=>	array
								(
									'min'										=>	1,
									'max'										=>	100
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'88'
						)
					),	
					array
					(
						'id'													=>	'subheader_font_size',
						'ui'													=>	array
						(
							'panel'												=>	4,
							'text'												=>	array
							(
								'header'										=>	__('Subheader font size',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Subheader font size (in PX).',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'slider',
								'value'											=>	24,
								'option'										=>	array
								(
									'min'										=>	1,
									'max'										=>	100
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'24'
						)
					),					
				)
			)
		);
		
		parent::__construct();		
	}

	/**************************************************************************/
	
	function processShortcodeImageCarousel($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);
		
		$option=array();
		
		$imageHTML=null;
		
		$Easing=new PBEasing();
		$Carousel=new PBCarouFredSel();
		$Validation=new PBValidation();

		$file=PBFile::getImage(explode(',',$attribute['image']));
		
		if($file===false) return;
		if(!count($file->posts)) return;
		
		if(!PBFile::isWPImage($attribute['image_size'])) return;
		
		if(!$Validation->isBool($attribute['autoplay_enable'])) return;
		if(!$Validation->isBool($attribute['circular_enable'])) return;
		if(!$Validation->isBool($attribute['infinite_enable'])) return;
		
		if(!$Validation->isBool($attribute['touch_enable'])) return;
		if(!$Validation->isBool($attribute['mouse_enable'])) return;
		
		if(!$Validation->isBool($attribute['preloader_enable'])) return;
		if(!$Validation->isBool($attribute['carousel_height_adjust'])) return;
		
		if(!$Validation->isEmpty($attribute['pause_on_hover']))
		{
			if(!array_key_exists($attribute['pause_on_hover'],$Carousel->pauseOnHover)) return;
		}
		
		if(!array_key_exists($attribute['direction'],$Carousel->direction)) return;
		
		if(!$Validation->isNumber($attribute['delay'],0,99999)) return;
		if(!$Validation->isNumber($attribute['timeout_duration'],0,99999)) return;
		
		if(!$Validation->isNumber($attribute['scroll_item'],0,999)) return;
		if(!$Validation->isNumber($attribute['timeout_duration'],0,99999)) return;
		
		if(!array_key_exists($attribute['scroll_fx'],$Carousel->scrollFX)) return;
		if(!array_key_exists($attribute['scroll_easing'],$Easing->easingType)) return;
		
		if(!$Validation->isNumber($attribute['caption_box_position'],0,100)) return;
		if(!$Validation->isNumber($attribute['pagination_box_position'],0,100)) return;
		if(!$Validation->isNumber($attribute['header_font_size'],1,100)) return;
		if(!$Validation->isNumber($attribute['subheader_font_size'],1,100)) return;
		
		$key=array
		(
			'autoplay_enable',
			'circular_enable',
			'infinite_enable',
			'touch_enable',
			'mouse_enable',
			'preloader_enable',
			'carousel_height_adjust',
			'pause_on_hover',
			'direction',
			'delay',
			'timeout_duration',
			'scroll_item',
			'scroll_duration',
			'scroll_fx',
			'scroll_easing',
			'caption_box_position',
			'pagination_box_position',
			'header_font_size',
			'subheader_font_size'
		);
		
		foreach($key as $index)
			$option[$index]=$attribute[$index];

		global $post;
		$bPost=$post;
		
		while($file->have_posts())
		{
			global $post;
			
			$file->the_post();
			
			$src=wp_get_attachment_image_src(get_the_ID(),$attribute['image_size']);
			
			$class=array();
			if($attribute['preloader_enable']==1)
				array_push($class,'pb-preloader-image');
		
			$meta=PBHelper::getPostMeta($post);
			PBHelper::removeUIndex($meta,'media_library_video_url','media_library_url');
			
			$header=null;
			$section=null;
			$subheader=null;
			
			if($Validation->isNotEmpty($post->post_excerpt))
				$header='<span class="pb-image-carousel-box-header">'.$post->post_excerpt.'</span>';
			if($Validation->isNotEmpty($post->post_content))
				$subheader='<span class="pb-image-carousel-box-subheader">'.$post->post_content.'</span>';			
			
			if(($Validation->isNotEmpty($header)) || ($Validation->isNotEmpty($subheader)))
			{
				$section.=
				'
					<div class="pb-main">
				';
				
				if($Validation->isNotEmpty($meta['media_library_url']))
					$section.='<a href="'.esc_attr($meta['media_library_url']).'">';
				
				$section.=
				'
					<span>
						'.$header.'
						'.$subheader.'	
					</span>
				';
						
				if($Validation->isNotEmpty($meta['media_library_url']))
					$section.='</a>';

				$section.=
				'
					</div>
				';					
			}

			$imageHTML.=
			'
				<li>
					<div'.PBHelper::createClassAttribute($class).'>
						<img src="'.$src[0].'" alt=""/>
						<div class="pb-image-carousel-box" style="top:'.(int)$attribute['caption_box_position'].'%">
							'.$section.'
						</div>
					</div>
				</li>
			';
		}
		
		wp_reset_query();
		$post=$bPost;
		
		$id=PBHelper::createId('pb_image_carousel');
		
		$class=array('pb-image-carousel');
		
		if($attribute['preloader_enable']==1)
			array_push($class,'pb-preloader');
		
		array_push($class,$attribute['css_class']);
		
		$html=
		'
			<div'.PBHelper::createClassAttribute($class).' id="'.$id.'">
				<ul class="pb-reset-list pb-clear-fix">
					'.$imageHTML.'
				</ul>
				<div class="pb-slider-pagination" style="bottom:'.(int)$attribute['pagination_box_position'].'%"></div>
			</div>
			<div class="pb-script-tag">
				<script type="text/javascript">
					jQuery(document).ready(function($)
					{
						$(\'#'.$id.'\').PBImageCarousel('.json_encode($option).');
					});
				</script>
			</div>
		';

		return(PBHelper::formatCode($html));
	}

	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>