/******************************************************************************/
/******************************************************************************/

;(function($,doc,win) 
{
	"use strict";
	
	var PBLayout=function(object,option)
	{
		/**********************************************************************/
		
		var $this=$(object);
		var $option=option;
		
		/**********************************************************************/

		this.build=function() 
		{
			if($option.bg_parallax_enable==1)
				$this.parallax({speed:parseInt($option.bg_parallax_speed)});
			
			$this.find('.pb-line-video-control-toggle-sound').bind('click',function(e) 
			{
				e.preventDefault();
				
				var video=$(this).parents('.pb-line').children('.pb-line-video').children('video')[0];
				
				if(video.muted)
				{
					$(this).removeClass('pb-line-video-control-toggle-sound-off').addClass('pb-line-video-control-toggle-sound-on');
					video.muted=false;
				}
				else
				{
					$(this).removeClass('pb-line-video-control-toggle-sound-on').addClass('pb-line-video-control-toggle-sound-off');
					video.muted=true;
				}
			});
			
			$this.find('.pb-line-video-control-toggle-play').bind('click',function(e) 
			{
				e.preventDefault();
				
				var video=$(this).parents('.pb-line').children('.pb-line-video').children('video')[0];
				
				if(video.paused)
				{
					$(this).removeClass('pb-line-video-control-toggle-play-off').addClass('pb-line-video-control-toggle-play-on');
					video.play();
				}
				else
				{
					$(this).removeClass('pb-line-video-control-toggle-play-on').addClass('pb-line-video-control-toggle-play-off');
					video.pause();
				}
			});
			
			this.animate();
		};
		
		/**********************************************************************/
		
		this.animate=function()
		{
			var helper=new PBHelper();
			
			switch($option.animation_type)
			{
				case 'slide':
			
					$this.children('ul').children('li').children('div').waypoint(function()
					{
						$(this).each(function() 
						{
							if(!helper.isAnimationComplete($(this)))
							{
								var direction='down';
								var parent=$(this).parent('li');
								
								if((parent.hasClass('pb-layout-column-left')) || (parent.hasClass('pb-layout-column-center-left')))
									direction='left';
								else if((parent.hasClass('pb-layout-column-right')) || (parent.hasClass('pb-layout-column-center-right')))
									direction='right';
								
								$(this).css({opacity:1,overflow:'visible'}).effect('slide',{direction:direction,distance:'75%'},parseInt($option.animation_duration));
								helper.setAnimationAsComplete($(this));
							}
						});
					},
					{
						offset	:	'90%'
					})
					.waypoint(function()
					{
						if(!helper.isAnimationComplete($(this)))
							$(this).css({opacity:0});
					},
					{
						offset	:	'200%'
					});
					
				break;
			}	
		};
		
		/**********************************************************************/
	}
	
	/**************************************************************************/
	
	$.fn.PBLayout=function(option) 
	{
		var line=new PBLayout(this,option);
		line.build();
	};
	
	/**************************************************************************/

})(jQuery,document,window);