<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentMenu extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$Easing=new PBEasing();
		
		add_theme_support('menus');
		
		$this->style=array
		(
			'superfish'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'superfish.css'
			),
			'menu'																=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);
		
		$this->script=array
		(
			'superfish'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'superfish.js'
			),
			'jquery-waypoint'													=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'jquery.waypoints.min.js'
			),
			'jquery-waypoints-sticky'											=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'jquery.waypoints-sticky.min.js'
			),
			'jquery-scrollTo'													=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'jquery.scrollTo.min.js'
			),
			'menu'																=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'PB.Menu.js'
			)
		);
		
		$this->responsiveLevel=(array)PBComponentData::get($this->getComponentId(),'responsive_level');
		
		$this->component=array
		(
			'name'																=>	__('Menu + Logo',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays Menu and logo',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Menu + Logo',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'element'														=>	array
				(
					array
					(
						'id'													=>	'logo_src',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Logo',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select a logo',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'browse-image',
							)
						)
					),		
					array
					(
						'id'													=>	'menu_id',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Menu',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select a menu',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->getMenuDictionary()),
								)
							)
						)
					),	
					array
					(
						'id'													=>	'responsive_level',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Responsive menu',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable responsive menu (list) when screen width is less than selected',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->responsiveLevel,'label'),
									'use_default'								=>	true
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'960'
						)
					),	
					array
					(
						'id'													=>	'sticky_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Sticky menu',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable sticky menu',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),						
					array
					(
						'id'													=>	'hide_scroll_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Hide menu on scroll',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Hide menu when page is scrolling',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),	
					array
					(
						'id'													=>	'hover_first_level_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Hover on first level menu elements',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Disable or enable hover on first level menu elements',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),					
					array
					(
						'id'													=>	'hover_next_level_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Hover on next levels menu elements',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Disable or enable hover on next levels menu elements',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),	
					array
					(
						'id'													=>	'animation_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Animation',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable animation during scrolling',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),
					array
					(
						'id'													=>	'animation_duration',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Duration',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Duration of animation in miliseconds.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	5
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1000'
						)
					),
					array
					(
						'id'													=>	'animation_easing',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Easing',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Easing method of animation.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($Easing->easingType)
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'easeOutQuint'
						)
					),					
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space.',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),
				)
			)
		);	
		
		parent::__construct();
	}
	
	/**************************************************************************/
	
	function getMenuDictionary()
	{
		$menu=get_terms('nav_menu');

		$data=array();
		
		foreach($menu as $singlePost)
			$data[$singlePost->term_id]=array($singlePost->name);
		
		return($data);
	}
	
	/**************************************************************************/

	function processShortcodeMenu($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);
	
		$Easing=new PBEasing();
		$Validation=new PBValidation();
		
		if(!$Validation->isBool($attribute['sticky_enable'])) return;
		if(!$Validation->isBool($attribute['hide_scroll_enable'])) return;
		if(!$Validation->isBool($attribute['hover_first_level_enable'])) return;
		if(!$Validation->isBool($attribute['hover_next_level_enable'])) return;
		
		if(!array_key_exists($attribute['responsive_level'],$this->responsiveLevel)) return;

		if(!$Validation->isBool($attribute['animation_enable'])) return;
		if(!$Validation->isNumber($attribute['animation_duration'],0,99999)) return;
		if(!array_key_exists($attribute['animation_easing'],$Easing->easingType)) return;
		
		$html=null;
		$logoHTML=null;
		
		$class=array();
		$option=array();

		$key=array
		(
			'sticky_enable',
			'responsive_level',
			'hide_scroll_enable',
			'animation_enable',
			'animation_duration',
			'animation_easing'
		);
		
		foreach($key as $value)
			$option[$value]=$attribute[$value];
		
		$id=PBHelper::createId('pb_menu');
		
		$classLogo=array('pb-logo','pb-layout-column-left');
		$classMenu=array('pb-menu','pb-layout-column-right');
		$classMenuResponsive=array('pb-menu-responsive','pb-layout-column-right');
		
		$class=array('pb-menu-logo',$attribute['css_class']);
		
		if($attribute['hover_first_level_enable']==1)
			array_push($classMenu,'pb-menu-hover-first-level');
		if($attribute['hover_next_level_enable']==1)
			array_push($classMenu,'pb-menu-hover-next-level');
		
		$menuAttribute=array
		(
			'menu'				=>	$attribute['menu_id'],
			'walker'			=>	new PBMenuWalker(),
			'menu_class'		=>	'sf-menu pb-reset-list pb-clear-fix',
			'container'			=>	'',
			'container_class'	=>	'',
			'echo'				=>	0
		);
		
		$menuResponsiveAttribute=array
		(
			'menu'				=>	$attribute['menu_id'],
			'walker'			=>	new PBMenuResponsiveWalker(),
			'menu_class'		=>	'pb-clear-fix',
			'container'			=>	'',
			'container_class'	=>	'',
			'echo'				=>	0,
			'items_wrap'		=>	'<select id="%1$s" class="%2$s">%3$s</select>'
		);
		
		if($Validation->isURL($attribute['logo_src']))
		{
			$logoHTML=
			'
				<a href="'.get_home_url().'">
					<img src="'.esc_attr($attribute['logo_src']).'" alt=""/>
				</a>
			';
		}
		
		$html=
		'
			<div'.PBHelper::createClassAttribute($class).' id="'.$id.'">
				<div class="pb-main pb-clear-fix pb-layout-25x75">
					<div'.PBHelper::createClassAttribute($classLogo).'>
						'.$logoHTML.'
					</div>
					<div'.PBHelper::createClassAttribute($classMenu).'>
						<div class="pb-menu-selected"></div>
						'.wp_nav_menu($menuAttribute).'
					</div>
					<div'.PBHelper::createClassAttribute($classMenuResponsive).'>
						'.wp_nav_menu($menuResponsiveAttribute).'
					</div>					
				</div>
			</div>
			<div class="pb-script-tag">
				<script type="text/javascript">
					jQuery(document).ready(function($)
					{
						$(\'#'.$id.'\').PBMenu('.json_encode($option).');
					});
				</script>
			</div>
		';
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>