/******************************************************************************/
/******************************************************************************/

;(function($,doc,win) 
{
	"use strict";
	
	var PBNivoSlider=function(object,option)
	{
		/**********************************************************************/
		
		var $this=$(object);
		var $option=option;

		/**********************************************************************/

		this.build=function() 
		{
			var self=this;
			
			var helper=new PBHelper();
			var loadClass=helper.addLoadClass();
			
			if($option.preloader_enable==1)
			{
				$this.preloaderImage(
				{
					animationEnable				:	false,
					onReady						:	function() 
					{
						var height=parseInt($this.find('div>img').actual('height'));
						$this.animate({'height':height},{duration:1000,easing:'easeOutQuint',complete:function() 
						{
							$this.css({'height':'auto'}).removeClass('pb-preloader');
							self.createSlider(loadClass);
						}});					
					}
				});
			}
			else
			{
				self.createSlider(loadClass);
			}
		};
		
		/**********************************************************************/
		
		this.createSlider=function(loadClass) 
		{
			var imageCount=$this.find('div').length;
			
			$this.nivoSlider(
			{
				effect					:	$option.transition_effect,               
				slices					:	parseInt($option.count_slice),                     
				boxCols					:	parseInt($option.count_column),                     
				boxRows					:	parseInt($option.count_row),                     
				animSpeed				:	parseInt($option.transition_speed),                 
				pauseTime				:	parseInt($option.pause_time),                
				startSlide				:	parseInt($option.start_slide),                 
				directionNav			:	parseInt($option.direction_navigation_enable)==1 ? true : false,             
				controlNav				:	parseInt($option.control_navigation_enable)==1 ? true : false,               
				controlNavThumbs		:	false,       
				pauseOnHover			:	parseInt($option.pause_on_hover)==1 ? true : false,           
				manualAdvance			:	parseInt($option.manual_advance_enable)==1 ? true : false,          
				prevText				:	'',             
				nextText				:	'',              
				randomStart				:	parseInt($option.random_start_enable)==1 ? true : false,            
				beforeChange			:	function(){},     
				afterChange				:	function(){},      
				slideshowEnd			:	function(){},     
				lastSlide				:	function(){},        
				afterLoad				:	function()
				{
					var pagination=$this.nextAll('.nivo-controlNav');

					pagination.addClass('pb-slider-pagination');
					pagination.children('a').html('').css({'width':((100/imageCount)-4)+'%','margin-right':'2%','margin-left':'2%'});
					pagination.css('display','block');
					
					var helper=new PBHelper();
					helper.removeLoadClass(loadClass);					
				}         
			});				
		};
		
		/**********************************************************************/
	}
	
	/**************************************************************************/
	
	$.fn.PBNivoSlider=function(option) 
	{
		var slider=new PBNivoSlider(this,option);
		slider.build();
	};
	
	/**************************************************************************/

})(jQuery,document,window);

/******************************************************************************/
/******************************************************************************/