/******************************************************************************/
/******************************************************************************/

function LNThemeMediaManager(managerId,destinationId,text)
{
	$this=this;
	$this.managerId=managerId;
	$this.destinationId=destinationId;
	$this.text=text;
	$this.openFileWindowAttribute=0;
};
	
/******************************************************************************/
	
LNThemeMediaManager.prototype.create=function()
{
	$this.buildFileData();
	
	$this.bindImage();
	$this.bindPagination();
	
	$this.bindImageSort();
	$this.bindImageDelete();
	
	$this.createWindow();
	
	$this.bindWindowSave();
	$this.bindWindowOpen();
};

/******************************************************************************/

LNThemeMediaManager.prototype.buildFileData=function()
{
	var index=0;
	var fileData=[];
	
	jQuery('#'+$this.destinationId+' li').each(function() 
	{
		fileData[index]={};
		
		fileData[index].id=$this.getFileIdByClassName(jQuery(this),'media-manager-file-');
		fileData[index].attribute=eval(jQuery(this).children(':input[name="media-manager-file-data"]').val());
		
		index++;
	});
	
	jQuery('#'+$this.destinationId+'_file_data').val(JSON.stringify(fileData));
};

/******************************************************************************/

LNThemeMediaManager.prototype.getFileIdByClassName=function(object,classPrefix)
{
	var className=object.attr('class').split(' ');
	
	for(var i in className)
	{
		if(className[i].indexOf(classPrefix)>=0)
			return(parseInt(className[i].substring(classPrefix.length)));
	}	
	
	return(0);
};

/******************************************************************************/

LNThemeMediaManager.prototype.bindPagination=function()
{
	jQuery('#'+$this.managerId).find('.media-manager-pagination a').bind('click',function(e) 
	{
		e.preventDefault();
		$this.blockPanel('block');
		$this.getMedia(jQuery(this));
	});
};

/******************************************************************************/

LNThemeMediaManager.prototype.bindImage=function()
{
	jQuery('#'+$this.managerId).find('.media-manager-source li').bind('click',function(e) 
	{
		e.preventDefault();

		var image=jQuery(this).clone(false,false).fadeOut();
		
		jQuery('#'+$this.destinationId).append(image).fadeIn(100,function() 
		{
			$this.buildFileData();
			$this.bindImageSort();
			$this.bindImageDelete();
			$this.bindWindowOpen();
		});
	});
};

/******************************************************************************/

LNThemeMediaManager.prototype.bindImageSort=function()
{
	jQuery('#'+$this.destinationId).sortable(
	{
		stop:function(event,ui)
		{
			$this.buildFileData();
		},
		placeholder: 'gallery-placeholder'
	});	
};

/******************************************************************************/

LNThemeMediaManager.prototype.bindImageDelete=function()
{
	jQuery('#'+$this.destinationId+'>li').removeAttr('title');
	
	jQuery('#'+$this.destinationId+'>li>a.media-manager-button-file-remove').unbind('click');
	jQuery('#'+$this.destinationId+'>li>a.media-manager-button-file-remove').bind('click',function(e)
	{
		e.preventDefault();
		if(confirm($this.text.delete_image))
		{
			jQuery(this).parent('li').fadeOut(100,function() { jQuery(this).remove(); $this.buildFileData(); });
		}
	});
};

/******************************************************************************/

LNThemeMediaManager.prototype.getMedia=function(object)
{
	var data={};
		
	data.id=$this.managerId;
	data.paged=parseInt(object.html());
	data.action='theme_admin_media_manager_get_media';
		
	jQuery.post(ajaxurl,data,function(response) 
	{
		$this.getMediaResponse(response);	
			
	},'json');	
};

/******************************************************************************/

LNThemeMediaManager.prototype.getMediaResponse=function(response)
{
	jQuery('#'+$this.managerId).find('.media-manager-source').html(response.fileList);
	jQuery('#'+$this.managerId).find('.media-manager-pagination').html(response.pagination);	
	
	$this.bindPagination();
	$this.bindImage();
	
	$this.blockPanel('unblock');
};

/******************************************************************************/

LNThemeMediaManager.prototype.blockPanel=function(action)
{
	if(action=='block')
		jQuery('#'+$this.managerId).find('.media-manager-source').block({message:false,overlayCSS:{opacity:'0.3'}});
	else jQuery('#'+$this.managerId).find('.media-manager-source').unblock();			
};

/******************************************************************************/

LNThemeMediaManager.prototype.createWindow=function()
{
	jQuery('#media-manager-window-'+$this.destinationId).dialog(
	{
		modal		:	true,
		autoOpen	:	false,
		resizable	:	false,
		width		:	555,
		height		:	600
	});	
};

/******************************************************************************/

LNThemeMediaManager.prototype.bindWindowSave=function()
{
	jQuery('#media-manager-window-'+$this.destinationId).find(':input[name="file_save"]').bind('click',function(e) 
	{
		e.preventDefault();
		var serialize=jQuery(this).parents('.media-manager-window').find('.media-manager-window-content-section :input').serializeArray();
		
		$this.openFile.children(':input[name="media-manager-file-data"]').val(JSON.stringify(serialize));

		$this.buildFileData();

		jQuery('#media-manager-window-'+$this.destinationId).dialog('close');
	});
};

/******************************************************************************/

LNThemeMediaManager.prototype.bindWindowOpen=function()
{	
	jQuery('#'+$this.destinationId+'>li>a.media-manager-button-file-attribute').unbind('click');
	jQuery('#'+$this.destinationId+'>li>a.media-manager-button-file-attribute').bind('click',function(e)
	{
		e.preventDefault();		
		$this.openFile=jQuery(this).parent('li');
		
		try
		{
			jQuery('#media-manager-window-'+$this.destinationId).find(':input[type="text"],textarea').val('');
			
			var data=JSON.parse(jQuery(this).parent('li').children(':input[name="media-manager-file-data"]').val());
			
			for(var i in data)
			{
				jQuery('#media-manager-window-'+$this.destinationId).find(':input[name="'+data[i].name+'"]').val(data[i].value);
			}
		}
		catch(e) {}

		jQuery('#media-manager-window-'+$this.destinationId).dialog('open');
	});
}

/******************************************************************************/